"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HMSAudioFilePlayerNode = void 0;
var _reactNative = require("react-native");
var _HMSAudioNode = require("./HMSAudioNode");
const {
  /**
   * @ignore
   */
  HMSManager
} = _reactNative.NativeModules;
class HMSAudioFilePlayerNode extends _HMSAudioNode.HMSAudioNode {
  constructor(name) {
    super(name);
  }
  setVolume(volume) {
    HMSManager.setAudioShareVolume({
      id: this.sdkId,
      audioNode: this.name,
      volume
    });
  }
  async play(fileUrl, loops, interrupts) {
    return await HMSManager.playAudioShare({
      id: this.sdkId,
      audioNode: this.name,
      fileUrl,
      loops,
      interrupts
    });
  }
  pause() {
    HMSManager.pauseAudioShare({
      id: this.sdkId,
      audioNode: this.name
    });
  }
  resume() {
    HMSManager.resumeAudioShare({
      id: this.sdkId,
      audioNode: this.name
    });
  }
  stop() {
    HMSManager.stopAudioShare({
      id: this.sdkId,
      audioNode: this.name
    });
  }
  async isPlaying() {
    return await HMSManager.audioShareIsPlaying({
      id: this.sdkId,
      audioNode: this.name
    });
  }
  async currentDuration() {
    return await HMSManager.audioShareCurrentTime({
      id: this.sdkId,
      audioNode: this.name
    });
  }
  async duration() {
    return await HMSManager.audioShareDuration({
      id: this.sdkId,
      audioNode: this.name
    });
  }
}
exports.HMSAudioFilePlayerNode = HMSAudioFilePlayerNode;
//# sourceMappingURL=HMSAudioFilePlayerNode.js.map