"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HMSAudioTrack = void 0;
var _HMSTrack = require("./HMSTrack");
/**
 * Represents an audio track within the HMS (100ms) system.
 *
 * This class extends `HMSTrack` to provide functionalities specific to audio tracks. It includes a constructor
 * that allows for the initialization of the audio track with various parameters such as track ID, source, description,
 * mute state, ID, and type. These parameters provide detailed information about the audio track and its characteristics.
 *
 * @extends HMSTrack
 */
class HMSAudioTrack extends _HMSTrack.HMSTrack {
  constructor(params) {
    if (params) {
      super(params);
    }
  }
}
exports.HMSAudioTrack = HMSAudioTrack;
//# sourceMappingURL=HMSAudioTrack.js.map