"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HMSCameraControl = void 0;
var _HMSConstants = require("./HMSConstants");
var _HMSManagerModule = _interopRequireDefault(require("../modules/HMSManagerModule"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
class HMSCameraControl {
  /**
   * It captures the image from the device camera at max possible resolution.
   *
   * @param {boolean} [flash=false] flash - value indicating whether to use flash while capturing image or not
   * @returns Promise - which is resolved with the file path of the captured image saved on the disk
   */
  static captureImageAtMaxSupportedResolution(flash = false) {
    return _HMSManagerModule.default.captureImageAtMaxSupportedResolution({
      id: _HMSConstants.HMSConstants.DEFAULT_SDK_ID,
      flash
    });
  }
}
exports.HMSCameraControl = HMSCameraControl;
//# sourceMappingURL=HMSCameraControl.js.map