"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HMSLocalAudioTrack = void 0;
var _reactNative = require("react-native");
var _HMSAudioTrack = require("./HMSAudioTrack");
var _HMSLogger = require("./HMSLogger");
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
const {
  /**
   * @ignore
   */
  HMSManager
} = _reactNative.NativeModules;
class HMSLocalAudioTrack extends _HMSAudioTrack.HMSAudioTrack {
  /**
   * Switches Audio of current user on/off depending upon the value of isMute
   *
   * @param {boolean} isMute
   * @memberof HMSLocalAudioTrack
   */
  setMute(isMute) {
    const logger = (0, _HMSLogger.getLogger)();
    logger === null || logger === void 0 || logger.verbose('#Function setMute', {
      trackId: this.trackId,
      id: this.id,
      source: this.source,
      type: this.type,
      isMute
    });
    HMSManager.setLocalMute({
      isMute,
      id: this.id
    });
  }
  constructor(params) {
    super(params);
    _defineProperty(this, "settings", void 0);
    _defineProperty(this, "id", void 0);
    _defineProperty(this, "getVolume", async () => {
      const logger = (0, _HMSLogger.getLogger)();
      logger === null || logger === void 0 || logger.verbose('#Function getVolume', {
        trackId: this.trackId,
        id: this.id,
        source: this.source,
        type: this.type
      });
      if (_reactNative.Platform.OS === 'ios') {
        return 'This API not available for IOS';
      }
      const volume = await HMSManager.getVolume({
        trackId: this.trackId,
        id: this.id
      });
      return volume;
    });
    this.id = params.id;
    this.settings = params.settings;
  }
}
exports.HMSLocalAudioTrack = HMSLocalAudioTrack;
//# sourceMappingURL=HMSLocalAudioTrack.js.map