"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HMSLocalVideoTrack = void 0;
var _reactNative = require("react-native");
var _HMSVideoTrack = require("./HMSVideoTrack");
var _HMSLogger = require("./HMSLogger");
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
const {
  /**
   * @ignore
   */
  HMSManager
} = _reactNative.NativeModules;
class HMSLocalVideoTrack extends _HMSVideoTrack.HMSVideoTrack {
  /**
   * Switches local video feed on/off depending upon the value of isMute
   *
   * @param {boolean} isMute
   * @memberof HMSLocalVideoTrack
   */
  setMute(isMute) {
    const logger = (0, _HMSLogger.getLogger)();
    logger === null || logger === void 0 || logger.verbose('#Function setMute', {
      trackId: this.trackId,
      source: this.source,
      type: this.type,
      id: this.id
    });
    HMSManager.setLocalVideoMute({
      isMute,
      id: this.id
    });
  }
  constructor(params) {
    super(params);
    _defineProperty(this, "settings", void 0);
    _defineProperty(this, "id", void 0);
    /**
     * switches camera between front/back
     *
     * @memberof HMSSDK
     */
    _defineProperty(this, "switchCamera", () => {
      const logger = (0, _HMSLogger.getLogger)();
      logger === null || logger === void 0 || logger.verbose('#Function switchCamera', {
        trackId: this.trackId,
        source: this.source,
        type: this.type,
        id: this.id
      });
      HMSManager.switchCamera({
        id: this.id
      });
    });
    this.settings = params.settings;
    this.id = params.id;
  }
}
exports.HMSLocalVideoTrack = HMSLocalVideoTrack;
//# sourceMappingURL=HMSLocalVideoTrack.js.map