"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HMSNetworkQuality = void 0;
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * Represents the network quality of a connection in the HMS (100ms) system.
 *
 * This class encapsulates the network quality information, specifically focusing on the downlink quality of the connection.
 * The downlink quality is represented as a numerical value, providing a quantifiable measure of the receiving end's network performance.
 *
 * @param {Object} params - The constructor parameters.
 * @param {number} params.downlinkQuality - The downlink quality of the network connection.
 *
 * @see https://www.100ms.live/docs/react-native/v2/how-to-guides/measure-network-quality-and-performance/network-quality
 */
class HMSNetworkQuality {
  constructor(params) {
    _defineProperty(this, "downlinkQuality", void 0);
    this.downlinkQuality = params.downlinkQuality;
  }
}
exports.HMSNetworkQuality = HMSNetworkQuality;
//# sourceMappingURL=HMSNetworkQuality.js.map