"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HMSPIPListenerActions = void 0;
/**
 * Enum for HMS Picture-in-Picture (PIP) Listener Actions.
 *
 * This enum defines the types of actions/events related to the Picture-in-Picture (PIP) mode that can be listened to
 * within the HMS SDK. These actions allow the application to respond to changes in PIP mode or when the room is left
 * while in PIP mode.
 *
 * @enum {string}
 */
let HMSPIPListenerActions = exports.HMSPIPListenerActions = /*#__PURE__*/function (HMSPIPListenerActions) {
  HMSPIPListenerActions["ON_PIP_MODE_CHANGED"] = "ON_PIP_MODE_CHANGED";
  HMSPIPListenerActions["ON_PIP_ROOM_LEAVE"] = "ON_PIP_ROOM_LEAVE";
  return HMSPIPListenerActions;
}({});
//# sourceMappingURL=HMSPIPListenerActions.js.map