"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HMSPeerListIterator = void 0;
var _HMSManagerModule = _interopRequireDefault(require("../modules/HMSManagerModule"));
var _reactNativeHms = require("@100mslive/react-native-hms");
var _HMSConstants = require("./HMSConstants");
var _HMSPeersCache = require("./HMSPeersCache");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); } // import type { HMSException } from "./HMSException";
class HMSPeerListIterator {
  get totalCount() {
    return this._totalCount;
  }
  constructor(uniqueId, totalCount) {
    _defineProperty(this, "uniqueId", void 0);
    _defineProperty(this, "_totalCount", 0);
    this.uniqueId = uniqueId;
    this._totalCount = totalCount;
  }
  async hasNext() {
    _reactNativeHms.logger === null || _reactNativeHms.logger === void 0 || _reactNativeHms.logger.verbose('#Function HMSPeerListIterator#hasNext', this.uniqueId);
    try {
      return _HMSManagerModule.default.peerListIteratorHasNext({
        id: _HMSConstants.HMSConstants.DEFAULT_SDK_ID,
        uniqueId: this.uniqueId
      });
    } catch (e) {
      _reactNativeHms.logger === null || _reactNativeHms.logger === void 0 || _reactNativeHms.logger.error('#Error in #Function HMSPeerListIterator#hasNext ', e);
      return Promise.reject(e);
    }
  }
  async next() {
    _reactNativeHms.logger === null || _reactNativeHms.logger === void 0 || _reactNativeHms.logger.verbose('#Function HMSPeerListIterator#next', this.uniqueId);
    try {
      const {
        totalCount,
        peers
      } = await _HMSManagerModule.default.peerListIteratorNext({
        id: _HMSConstants.HMSConstants.DEFAULT_SDK_ID,
        uniqueId: this.uniqueId
      });
      this._totalCount = totalCount;
      if (Array.isArray(peers) && peers.length > 0) {
        const hmsPeersCache = (0, _HMSPeersCache.getHmsPeersCache)();
        if (hmsPeersCache) {
          peers.forEach(peer => {
            hmsPeersCache.updatePeerCache(peer.peerID, peer);
          });
        }
      }
      return _reactNativeHms.HMSEncoder.encodeHmsPeers(peers);
    } catch (e) {
      _reactNativeHms.logger === null || _reactNativeHms.logger === void 0 || _reactNativeHms.logger.error('#Error in #Function HMSPeerListIterator#next ', e);
      return Promise.reject(e);
    }
  }
}
exports.HMSPeerListIterator = HMSPeerListIterator;
//# sourceMappingURL=HMSPeerListIterator.js.map