"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HMSRemoteAudioTrack = void 0;
var _reactNative = require("react-native");
var _HMSLogger = require("./HMSLogger");
var _HMSAudioTrack = require("./HMSAudioTrack");
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
const {
  /**
   * @ignore
   */
  HMSManager
} = _reactNative.NativeModules;
class HMSRemoteAudioTrack extends _HMSAudioTrack.HMSAudioTrack {
  /**
   * Switches Audio of remote user on/off depending upon the value of playbackAllowed
   *
   * @param {boolean} playbackAllowed
   * @memberof HMSRemoteAudioTrack
   */
  setPlaybackAllowed(playbackAllowed) {
    const logger = (0, _HMSLogger.getLogger)();
    logger === null || logger === void 0 || logger.verbose('#Function setPlaybackAllowed', {
      trackId: this.trackId,
      id: this.id,
      source: this.source,
      type: this.type,
      playbackAllowed
    });
    HMSManager.setPlaybackAllowed({
      id: this.id,
      trackId: this.trackId,
      playbackAllowed
    });
  }
  constructor(params) {
    super(params);
    _defineProperty(this, "isPlaybackAllowed", async () => {
      try {
        const logger = (0, _HMSLogger.getLogger)();
        logger === null || logger === void 0 || logger.verbose('#Function isPlaybackAllowed', {
          trackId: this.trackId,
          id: this.id,
          source: this.source,
          type: this.type
        });
        const val = await HMSManager.isPlaybackAllowed({
          id: this.id,
          trackId: this.trackId
        });
        return val;
      } catch (e) {
        return true;
      }
    });
  }
}
exports.HMSRemoteAudioTrack = HMSRemoteAudioTrack;
//# sourceMappingURL=HMSRemoteAudioTrack.js.map