"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HMSRoom = void 0;
var _HMSRoomCache = require("./HMSRoomCache");
var _HMSConstants = require("./HMSConstants");
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
class HMSRoom {
  // startedAt?: Date;

  constructor(params) {
    _defineProperty(this, "id", void 0);
    this.id = params.id;
    // this.startedAt = params.startedAt;
  }
  get sessionId() {
    const hmsRoomCache = (0, _HMSRoomCache.getHmsRoomCache)();
    if (hmsRoomCache) {
      return hmsRoomCache.getProperty('sessionId');
    }
    return (0, _HMSRoomCache.getHMSRoomPropertyFromNative)(_HMSConstants.HMSConstants.DEFAULT_SDK_ID, 'sessionId');
  }
  get name() {
    const hmsRoomCache = (0, _HMSRoomCache.getHmsRoomCache)();
    if (hmsRoomCache) {
      return hmsRoomCache.getProperty('name');
    }
    return (0, _HMSRoomCache.getHMSRoomPropertyFromNative)(_HMSConstants.HMSConstants.DEFAULT_SDK_ID, 'name');
  }
  get metaData() {
    const hmsRoomCache = (0, _HMSRoomCache.getHmsRoomCache)();
    if (hmsRoomCache) {
      return hmsRoomCache.getProperty('metaData');
    }
    return (0, _HMSRoomCache.getHMSRoomPropertyFromNative)(_HMSConstants.HMSConstants.DEFAULT_SDK_ID, 'metaData');
  }
  get peers() {
    const hmsRoomCache = (0, _HMSRoomCache.getHmsRoomCache)();
    if (hmsRoomCache) {
      return hmsRoomCache.getProperty('peers');
    }
    return (0, _HMSRoomCache.getHMSRoomPropertyFromNative)(_HMSConstants.HMSConstants.DEFAULT_SDK_ID, 'peers');
  }
  get browserRecordingState() {
    const hmsRoomCache = (0, _HMSRoomCache.getHmsRoomCache)();
    if (hmsRoomCache) {
      return hmsRoomCache.getProperty('browserRecordingState');
    }
    return (0, _HMSRoomCache.getHMSRoomPropertyFromNative)(_HMSConstants.HMSConstants.DEFAULT_SDK_ID, 'browserRecordingState');
  }
  get rtmpHMSRtmpStreamingState() {
    const hmsRoomCache = (0, _HMSRoomCache.getHmsRoomCache)();
    if (hmsRoomCache) {
      return hmsRoomCache.getProperty('rtmpHMSRtmpStreamingState');
    }
    return (0, _HMSRoomCache.getHMSRoomPropertyFromNative)(_HMSConstants.HMSConstants.DEFAULT_SDK_ID, 'rtmpHMSRtmpStreamingState');
  }
  get serverRecordingState() {
    const hmsRoomCache = (0, _HMSRoomCache.getHmsRoomCache)();
    if (hmsRoomCache) {
      return hmsRoomCache.getProperty('serverRecordingState');
    }
    return (0, _HMSRoomCache.getHMSRoomPropertyFromNative)(_HMSConstants.HMSConstants.DEFAULT_SDK_ID, 'serverRecordingState');
  }
  get hlsStreamingState() {
    const hmsRoomCache = (0, _HMSRoomCache.getHmsRoomCache)();
    if (hmsRoomCache) {
      return hmsRoomCache.getProperty('hlsStreamingState');
    }
    return (0, _HMSRoomCache.getHMSRoomPropertyFromNative)(_HMSConstants.HMSConstants.DEFAULT_SDK_ID, 'hlsStreamingState');
  }
  get hlsRecordingState() {
    const hmsRoomCache = (0, _HMSRoomCache.getHmsRoomCache)();
    if (hmsRoomCache) {
      return hmsRoomCache.getProperty('hlsRecordingState');
    }
    return (0, _HMSRoomCache.getHMSRoomPropertyFromNative)(_HMSConstants.HMSConstants.DEFAULT_SDK_ID, 'hlsRecordingState');
  }
  get peerCount() {
    const hmsRoomCache = (0, _HMSRoomCache.getHmsRoomCache)();
    if (hmsRoomCache) {
      return hmsRoomCache.getProperty('peerCount');
    }
    return (0, _HMSRoomCache.getHMSRoomPropertyFromNative)(_HMSConstants.HMSConstants.DEFAULT_SDK_ID, 'peerCount');
  }
  get localPeer() {
    const hmsRoomCache = (0, _HMSRoomCache.getHmsRoomCache)();
    if (hmsRoomCache) {
      return hmsRoomCache.getProperty('localPeer');
    }
    return (0, _HMSRoomCache.getHMSRoomPropertyFromNative)(_HMSConstants.HMSConstants.DEFAULT_SDK_ID, 'localPeer');
  }
  get isLargeRoom() {
    const hmsRoomCache = (0, _HMSRoomCache.getHmsRoomCache)();
    if (hmsRoomCache) {
      return hmsRoomCache.getProperty('isLargeRoom');
    }
    return (0, _HMSRoomCache.getHMSRoomPropertyFromNative)(_HMSConstants.HMSConstants.DEFAULT_SDK_ID, 'isLargeRoom');
  }
  get transcriptions() {
    const hmsRoomCache = (0, _HMSRoomCache.getHmsRoomCache)();
    if (hmsRoomCache) {
      return hmsRoomCache.getProperty('transcriptions');
    }
    return (0, _HMSRoomCache.getHMSRoomPropertyFromNative)(_HMSConstants.HMSConstants.DEFAULT_SDK_ID, 'transcriptions');
  }
}
exports.HMSRoom = HMSRoom;
//# sourceMappingURL=HMSRoom.js.map