"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HMSRtmpVideoResolution = void 0;
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * Represents the video resolution for RTMP streaming in the HMS (100ms) system.
 *
 * This class encapsulates the dimensions (height and width) of the video resolution to be used for RTMP streaming.
 * It allows for specifying the video quality by defining the resolution, which is crucial for optimizing the streaming experience
 * based on the bandwidth available and the requirements of the streaming platform.
 *
 * @param {Object} params - The constructor parameters.
 * @param {number} params.height - The height of the video resolution.
 * @param {number} params.width - The width of the video resolution.
 *
 * @see https://www.100ms.live/docs/react-native/v2/how-to-guides/record-and-live-stream/recording
 */
class HMSRtmpVideoResolution {
  constructor(params) {
    _defineProperty(this, "height", void 0);
    _defineProperty(this, "width", void 0);
    this.height = params.height;
    this.width = params.width;
  }
}
exports.HMSRtmpVideoResolution = HMSRtmpVideoResolution;
//# sourceMappingURL=HMSRtmpVideoResolution.js.map