"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HMSTrackSettings = void 0;
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * Represents the settings for both video and audio tracks in a HMS (100ms) application.
 *
 * This class encapsulates the configurations for video and audio tracks that can be used
 * in a HMS session.
 *
 * @property {HMSVideoTrackSettings} video - Optional video track settings.
 * @property {HMSAudioTrackSettings} audio - Optional audio track settings.
 *
 */
class HMSTrackSettings {
  constructor(params) {
    _defineProperty(this, "video", void 0);
    _defineProperty(this, "audio", void 0);
    if (params) {
      this.video = params.video;
      this.audio = params.audio;
    }
  }
}
exports.HMSTrackSettings = HMSTrackSettings;
//# sourceMappingURL=HMSTrackSettings.js.map