"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HMSTrackSource = void 0;
/**
 * Enum for HMS Track Source types.
 *
 * Defines the source of an HMS track, indicating whether the track originates from a plugin, is a regular track, or is a screen-sharing track.
 *
 * @enum {string}
 * @property {string} REGULAR - Represents a regular track, typically from a user's camera or microphone.
 * @property {string} SCREEN - Represents a track that shares the screen.
 * @property {string} PLUGIN - Represents a track sourced from a plugin.
 */
let HMSTrackSource = exports.HMSTrackSource = /*#__PURE__*/function (HMSTrackSource) {
  HMSTrackSource["PLUGIN"] = "plugin";
  HMSTrackSource["REGULAR"] = "regular";
  HMSTrackSource["SCREEN"] = "screen";
  return HMSTrackSource;
}({});
//# sourceMappingURL=HMSTrackSource.js.map