"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HMSVideoTrack = void 0;
var _HMSTrack = require("./HMSTrack");
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * Represents a video track within the HMS (100ms) system.
 *
 * This class extends `HMSTrack` to provide functionalities specific to video tracks. It includes additional
 * property `isDegraded` to indicate whether the video quality has been intentionally reduced, typically for
 * performance reasons. The constructor allows for the initialization of the video track with various parameters
 * such as track ID, source, description, mute state, degradation state, ID, and type. These parameters provide
 * detailed information about the video track and its characteristics.
 *
 * @extends HMSTrack
 *
 * @see https://www.100ms.live/docs/react-native/v2/how-to-guides/set-up-video-conferencing/render-video/overview
 */
class HMSVideoTrack extends _HMSTrack.HMSTrack {
  constructor(params) {
    super(params);
    /**
     * Indicates whether the video quality of the track is degraded.
     * @type {boolean | undefined}
     */
    _defineProperty(this, "isDegraded", void 0);
    this.isDegraded = params.isDegraded;
  }
}
exports.HMSVideoTrack = HMSVideoTrack;
//# sourceMappingURL=HMSVideoTrack.js.map