"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registerWhiteboardUpdateListener = registerWhiteboardUpdateListener;
exports.unregisterWhiteboardUpdateListener = unregisterWhiteboardUpdateListener;
var _HMSConstants = require("../HMSConstants");
var _HMSNativeEventListener = _interopRequireDefault(require("../HMSNativeEventListener"));
var _HMSWhiteboardListenerActions = require("./HMSWhiteboardListenerActions");
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
let whiteboardUpdateSubscription = null;
function registerWhiteboardUpdateListener(listener) {
  if (whiteboardUpdateSubscription !== null) {
    return;
  }
  whiteboardUpdateSubscription = _HMSNativeEventListener.default.addListener(_HMSConstants.HMSConstants.DEFAULT_SDK_ID, _HMSWhiteboardListenerActions.HMSWhiteboardListenerActions.ON_WHITEBOARD_UPDATE, listener);
}
function unregisterWhiteboardUpdateListener() {
  if (whiteboardUpdateSubscription === null) {
    return;
  }
  whiteboardUpdateSubscription.remove();
  whiteboardUpdateSubscription = null;
}
//# sourceMappingURL=registerCallbacks.js.map