"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HMSHLSPlayer = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
var _hooks = require("./hooks");
var _RCTHMSHLSPlayer = require("./RCTHMSHLSPlayer");
var _types = require("../../types");
var _HMSEncoder = require("../../classes/HMSEncoder");
var _hmsStore = require("../../stores/hms-store");
var _hlsPlayerStatsStore = require("../../stores/hls-player-stats-store");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const _HMSHLSPlayer = ({
  url = '',
  style,
  containerStyle,
  enableStats,
  enableControls = false
}, ref) => {
  const hmsHlsPlayerRef = (0, _react.useRef)(null);
  const promiseAndIdsMap = (0, _react.useMemo)(() => new Map(), []);
  const currentRequestId = (0, _react.useRef)(1);
  (0, _react.useImperativeHandle)(ref, () => ({
    play: url => {
      if (hmsHlsPlayerRef.current && _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.play) {
        _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(hmsHlsPlayerRef.current), _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.play, url ? [url] : ['']);
      }
    },
    stop: () => {
      if (hmsHlsPlayerRef.current && _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.stop) {
        _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(hmsHlsPlayerRef.current), _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.stop, undefined);
      }
    },
    pause: () => {
      if (hmsHlsPlayerRef.current && _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.pause) {
        _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(hmsHlsPlayerRef.current), _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.pause, undefined);
      }
    },
    resume: () => {
      if (hmsHlsPlayerRef.current && _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.resume) {
        _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(hmsHlsPlayerRef.current), _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.resume, undefined);
      }
    },
    seekForward: seconds => {
      if (typeof seconds !== 'number') {
        throw new Error(seconds ? 'seconds must be a `number` type' : 'seconds was not provided');
      }
      if (hmsHlsPlayerRef.current && _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.seekForward) {
        _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(hmsHlsPlayerRef.current), _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.seekForward, [seconds]);
      }
    },
    seekBackward: seconds => {
      if (typeof seconds !== 'number') {
        throw new Error(seconds ? 'seconds must be a `number` type' : 'seconds was not provided');
      }
      if (hmsHlsPlayerRef.current && _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.seekBackward) {
        _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(hmsHlsPlayerRef.current), _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.seekBackward, [seconds]);
      }
    },
    seekToLivePosition: () => {
      if (hmsHlsPlayerRef.current && _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.seekToLivePosition) {
        _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(hmsHlsPlayerRef.current), _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.seekToLivePosition, undefined);
      }
    },
    setVolume: level => {
      if (typeof level !== 'number') {
        throw new Error(level ? 'level must be a `number` type' : 'level was not provided');
      }
      if (hmsHlsPlayerRef.current && _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.setVolume) {
        _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(hmsHlsPlayerRef.current), _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.setVolume, [level]);
      }
    },
    isClosedCaptionSupported: () => {
      if (hmsHlsPlayerRef.current && _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.areClosedCaptionSupported) {
        const requestId = currentRequestId.current++;
        const promise = new Promise((resolve, reject) => {
          promiseAndIdsMap.set(requestId, {
            resolve,
            reject
          });
        });
        _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(hmsHlsPlayerRef.current), _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.areClosedCaptionSupported, [requestId]);
        return promise;
      }
      return Promise.resolve(false);
    },
    isClosedCaptionEnabled: () => {
      if (hmsHlsPlayerRef.current && _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.isClosedCaptionEnabled) {
        const requestId = currentRequestId.current++;
        const promise = new Promise((resolve, reject) => {
          promiseAndIdsMap.set(requestId, {
            resolve,
            reject
          });
        });
        _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(hmsHlsPlayerRef.current), _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.isClosedCaptionEnabled, [requestId]);
        return promise;
      }
      return Promise.resolve(false);
    },
    enableClosedCaption: () => {
      if (hmsHlsPlayerRef.current && _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.enableClosedCaption) {
        _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(hmsHlsPlayerRef.current), _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.enableClosedCaption, undefined);
      }
    },
    disableClosedCaption: () => {
      if (hmsHlsPlayerRef.current && _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.disableClosedCaption) {
        _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(hmsHlsPlayerRef.current), _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.disableClosedCaption, undefined);
      }
    },
    getPlayerDurationDetails: () => {
      if (hmsHlsPlayerRef.current && _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.getPlayerDurationDetails) {
        const requestId = currentRequestId.current++;
        const promise = new Promise((resolve, reject) => {
          promiseAndIdsMap.set(requestId, {
            resolve,
            reject
          });
        });
        _reactNative.UIManager.dispatchViewManagerCommand((0, _reactNative.findNodeHandle)(hmsHlsPlayerRef.current), _RCTHMSHLSPlayer.RCTHMSHLSPlayerViewManagerConfig.Commands.getPlayerDurationDetails, [requestId]);
        return promise;
      }
      return Promise.resolve({
        streamDuration: undefined,
        rollingWindowTime: undefined
      });
    }
  }), [currentRequestId, promiseAndIdsMap]);

  // Handle HLS Playback events
  const handleHLSPlaybackEvent = ({
    nativeEvent
  }) => {
    const {
      event,
      data
    } = nativeEvent;
    if (event === _types.HMSHLSPlayerPlaybackEventTypes.ON_PLAYBACK_CUE_EVENT) {
      const transformedData = _HMSEncoder.HMSEncoder.transformHMSHLSCueEventData(data);
      (0, _hooks.setHMSHLSPlayerCue)(transformedData);
    } else if (event === _types.HMSHLSPlayerPlaybackEventTypes.ON_PLAYBACK_FAILURE_EVENT) {
      (0, _hooks.setHMSHLSPlayerPlaybackError)(data.error);
    } else if (event === _types.HMSHLSPlayerPlaybackEventTypes.ON_PLAYBACK_RESOLUTION_CHANGE_EVENT) {
      (0, _hooks.setHMSHLSPlayerResolution)({
        ...data
      });
    } else {
      (0, _hooks.setHMSHLSPlayerPlaybackState)(data.state);
    }
  };

  // Handle HLS Stats events
  const handleHLSStatsEvent = ({
    nativeEvent
  }) => {
    const {
      event,
      data
    } = nativeEvent;
    if (event === _types.HMSHLSPlayerStatsEventTypes.ON_STATS_EVENT_ERROR) {
      (0, _hooks.setHMSHLSPlayerStatsError)(data);
    } else {
      (0, _hooks.setHMSHLSPlayerStats)(data);
    }
  };

  // Handle HLS Player Cues events (e.g. usage - Closed Captions)
  const handleHLSPlayerCuesEvent = ({
    nativeEvent
  }) => {
    const {
      event,
      data
    } = nativeEvent;
    if (event === 'ON_CLOSED_CAPTION_UPDATE') {
      (0, _hooks.setHMSHLSPlayerSubtitles)(data);
    }
  };

  // Handle Requested data
  const handleRequestedDataReturned = ({
    nativeEvent
  }) => {
    const {
      requestId,
      data
    } = nativeEvent;
    const promiseMethods = promiseAndIdsMap.get(requestId);
    if (!promiseMethods) {
      console.warn('#function handleRequestedDataReturned', "Didn't found promise methods by requestId: ", requestId);
      return;
    }
    promiseMethods.resolve(data);
  };
  (0, _react.useEffect)(() => {
    return () => {
      _hmsStore.useHMSStore.getState().resetPlaybackSlice();
      _hlsPlayerStatsStore.useHMSHLSPlayerStatsStore.getState().reset();
    };
  }, []);
  return /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [styles.container, containerStyle]
  }, /*#__PURE__*/_react.default.createElement(_reactNative.View, {
    style: [styles.playerWrapper, style]
  }, /*#__PURE__*/_react.default.createElement(_RCTHMSHLSPlayer.RCTHMSHLSPlayer, {
    ref: hmsHlsPlayerRef,
    url: url,
    style: styles.player,
    enableStats: enableStats,
    enableControls: enableControls,
    onHmsHlsPlaybackEvent: handleHLSPlaybackEvent,
    onHmsHlsStatsEvent: handleHLSStatsEvent,
    onHlsPlayerCuesEvent: _reactNative.Platform.OS === 'android' ? handleHLSPlayerCuesEvent : undefined,
    onDataReturned: handleRequestedDataReturned
  })));
};
const HMSHLSPlayer = exports.HMSHLSPlayer = /*#__PURE__*/_react.default.forwardRef(_HMSHLSPlayer);
const styles = _reactNative.StyleSheet.create({
  container: {
    flex: 1,
    alignItems: 'center',
    justifyContent: 'center'
  },
  playerWrapper: {
    backgroundColor: '#000000',
    alignItems: 'center',
    justifyContent: 'center'
  },
  player: {
    width: '100%',
    height: '100%',
    flex: 1
  }
});
//# sourceMappingURL=HMSHLSPlayer.js.map