function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
// import type { HMSException } from "./HMSException";

import HMSManagerModule from '../modules/HMSManagerModule';
import { HMSEncoder, logger } from '@100mslive/react-native-hms';
import { HMSConstants } from './HMSConstants';
import { getHmsPeersCache } from './HMSPeersCache';
export class HMSPeerListIterator {
  get totalCount() {
    return this._totalCount;
  }
  constructor(uniqueId, totalCount) {
    _defineProperty(this, "uniqueId", void 0);
    _defineProperty(this, "_totalCount", 0);
    this.uniqueId = uniqueId;
    this._totalCount = totalCount;
  }
  async hasNext() {
    logger === null || logger === void 0 || logger.verbose('#Function HMSPeerListIterator#hasNext', this.uniqueId);
    try {
      return HMSManagerModule.peerListIteratorHasNext({
        id: HMSConstants.DEFAULT_SDK_ID,
        uniqueId: this.uniqueId
      });
    } catch (e) {
      logger === null || logger === void 0 || logger.error('#Error in #Function HMSPeerListIterator#hasNext ', e);
      return Promise.reject(e);
    }
  }
  async next() {
    logger === null || logger === void 0 || logger.verbose('#Function HMSPeerListIterator#next', this.uniqueId);
    try {
      const {
        totalCount,
        peers
      } = await HMSManagerModule.peerListIteratorNext({
        id: HMSConstants.DEFAULT_SDK_ID,
        uniqueId: this.uniqueId
      });
      this._totalCount = totalCount;
      if (Array.isArray(peers) && peers.length > 0) {
        const hmsPeersCache = getHmsPeersCache();
        if (hmsPeersCache) {
          peers.forEach(peer => {
            hmsPeersCache.updatePeerCache(peer.peerID, peer);
          });
        }
      }
      return HMSEncoder.encodeHmsPeers(peers);
    } catch (e) {
      logger === null || logger === void 0 || logger.error('#Error in #Function HMSPeerListIterator#next ', e);
      return Promise.reject(e);
    }
  }
}
//# sourceMappingURL=HMSPeerListIterator.js.map