function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * Configuration class for RTMP streaming in the HMS (100ms) system.
 *
 * This class encapsulates the settings required to configure RTMP (Real-Time Messaging Protocol) streaming for a meeting.
 * It includes options for the meeting URL, RTMP URLs for streaming, whether recording should be enabled, and the video resolution for the stream.
 *
 * @param {Object} params - The constructor parameters.
 * @param {string} [params.meetingURL] - The URL of the meeting to be streamed. Optional.
 * @param {Array<string>} [params.rtmpURLs] - An array of RTMP URLs to which the meeting will be streamed. Optional.
 * @param {boolean} params.record - Flag indicating whether the stream should be recorded.
 * @param {HMSRtmpVideoResolution} [params.resolution] - The resolution of the video to be streamed. Optional.
 *
 * @see https://www.100ms.live/docs/react-native/v2/how-to-guides/record-and-live-stream/recording
 */
export class HMSRTMPConfig {
  constructor(params) {
    _defineProperty(this, "meetingURL", void 0);
    _defineProperty(this, "rtmpURLs", void 0);
    _defineProperty(this, "record", void 0);
    _defineProperty(this, "resolution", void 0);
    this.meetingURL = params.meetingURL;
    this.rtmpURLs = params.rtmpURLs;
    this.record = params.record;
    this.resolution = params.resolution;
  }
}
//# sourceMappingURL=HMSRTMPConfig.js.map