function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * Represents a generic track within the HMS (100ms) system.
 *
 * This class serves as a base for different types of tracks (audio, video, etc.) within the HMS system. It encapsulates
 * common properties and functionalities that are shared across different track types.
 *
 * @property {string} trackId - The unique identifier for the track.
 * @property {HMSTrackSource} [source] - The source of the track, indicating whether it's from a plugin, regular input, or screen sharing.
 * @property {string} [trackDescription] - A brief description of the track.
 * @property {boolean} [mute] - Indicates whether the track is currently muted.
 * @property {string} id - A secondary identifier for the track.
 * @property {HMSTrackType} [type] - The type of the track, distinguishing between audio and video.
 */
export class HMSTrack {
  constructor(params) {
    _defineProperty(this, "trackId", void 0);
    _defineProperty(this, "source", void 0);
    _defineProperty(this, "trackDescription", void 0);
    _defineProperty(this, "mute", void 0);
    _defineProperty(this, "id", void 0);
    _defineProperty(this, "type", void 0);
    _defineProperty(this, "isMute", () => {
      return this.mute;
    });
    this.trackId = params.trackId;
    this.source = params.source;
    this.trackDescription = params.trackDescription;
    this.mute = params.isMute;
    this.id = params.id;
    this.type = params.type;
  }
}
//# sourceMappingURL=HMSTrack.js.map