function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * Represents the settings for a video track in a HMS (100ms) application.
 *
 * This class encapsulates the configurations for video tracks that can be used
 * in a HMS session.
 *
 * @property {HMSSimulcastLayerSettings[]} simulcastSettings - Optional simulcast settings.
 * @property {HMSTrackSettingsInitState} initialState - Optional initial state for the track.
 * @property {HMSCameraFacing} cameraFacing - Optional camera facing for the track.
 * @property {boolean} forceSoftwareDecoder - Optional flag to force software decoder.
 * @property {boolean} disableAutoResize - Optional flag to disable auto resize.
 * @property {HMSVirtualBackgroundPlugin} videoPlugin - Optional video plugin settings.
 *
 * @see https://www.100ms.live/docs/react-native/v2/how-to-guides/interact-with-room/track/track-settings
 */
export class HMSVideoTrackSettings {
  constructor(params) {
    _defineProperty(this, "simulcastSettings", void 0);
    _defineProperty(this, "initialState", void 0);
    _defineProperty(this, "cameraFacing", void 0);
    _defineProperty(this, "forceSoftwareDecoder", void 0);
    // android only
    _defineProperty(this, "disableAutoResize", void 0);
    // android only
    _defineProperty(this, "videoPlugin", void 0);
    this.simulcastSettings = params.simulcastSettings;
    this.initialState = params.initialState;
    this.cameraFacing = params.cameraFacing;
    this.forceSoftwareDecoder = params.forceSoftwareDecoder;
    this.disableAutoResize = params.disableAutoResize;
    this.videoPlugin = params.videoPlugin;
  }
}
//# sourceMappingURL=HMSVideoTrackSettings.js.map