import { HMSConstants } from '../HMSConstants';
import HMSNativeEventListener from '../HMSNativeEventListener';
import { HMSWhiteboardListenerActions } from './HMSWhiteboardListenerActions';
let whiteboardUpdateSubscription = null;
export function registerWhiteboardUpdateListener(listener) {
  if (whiteboardUpdateSubscription !== null) {
    return;
  }
  whiteboardUpdateSubscription = HMSNativeEventListener.addListener(HMSConstants.DEFAULT_SDK_ID, HMSWhiteboardListenerActions.ON_WHITEBOARD_UPDATE, listener);
}
export function unregisterWhiteboardUpdateListener() {
  if (whiteboardUpdateSubscription === null) {
    return;
  }
  whiteboardUpdateSubscription.remove();
  whiteboardUpdateSubscription = null;
}
//# sourceMappingURL=registerCallbacks.js.map