import { HMSTrack } from './HMSTrack';
import { HMSAudioTrack } from './HMSAudioTrack';
import { HMSVideoTrack } from './HMSVideoTrack';
import { HMSRoom } from './HMSRoom';
import { HMSPeer } from './HMSPeer';
import { HMSLocalPeer } from './HMSLocalPeer';
import { HMSRemotePeer } from './HMSRemotePeer';
import { HMSAudioTrackSettings } from './HMSAudioTrackSettings';
import { HMSVideoTrackSettings } from './HMSVideoTrackSettings';
import { HMSLocalVideoTrack } from './HMSLocalVideoTrack';
import { HMSLocalAudioTrack } from './HMSLocalAudioTrack';
import { HMSRole } from './HMSRole';
import { HMSRoleChangeRequest } from './HMSRoleChangeRequest';
import { HMSChangeTrackStateRequest } from './HMSChangeTrackStateRequest';
import { HMSVideoResolution } from './HMSVideoResolution';
import { HMSRTCStats } from './HMSRTCStats';
import { HMSRTCStatsReport } from './HMSRTCStatsReport';
import { HMSRemoteAudioTrack } from './HMSRemoteAudioTrack';
import { HMSRemoteVideoTrack } from './HMSRemoteVideoTrack';
import { HMSSpeaker } from './HMSSpeaker';
import { HMSHLSRecordingState } from './HMSHLSRecordingState';
import { HMSNetworkQuality } from './HMSNetworkQuality';
import { HMSBrowserRecordingState } from './HMSBrowserRecordingState';
import { HMSHLSStreamingState } from './HMSHLSStreamingState';
import { HMSHLSVariant } from './HMSHLSVariant';
import { HMSRtmpStreamingState } from './HMSRtmpStreamingState';
import { HMSServerRecordingState } from './HMSServerRecordingState';
import { HMSMessage } from './HMSMessage';
import { HMSMessageRecipient } from './HMSMessageRecipient';
import { HMSException } from './HMSException';
import { HMSLocalAudioStats } from './HMSLocalAudioStats';
import { HMSLocalVideoStats } from './HMSLocalVideoStats';
import { HMSRemoteAudioStats } from './HMSRemoteAudioStats';
import { HMSRemoteVideoStats } from './HMSRemoteVideoStats';
import { HMSSimulcastLayerDefinition } from './HMSSimulcastLayerDefinition';
import { HMSQualityLimitationReasons } from './HMSQualityLimitationReasons';
import { HMSHLSPlaylistType } from './HMSHLSPlaylistType';
import type { Transcriptions } from './transcriptions';
export declare class HMSEncoder {
    private static data;
    static clearData(): void;
    static encodeHmsRoom(room: any, id: string): HMSRoom;
    static encodeHmsPeers(peers: any): HMSPeer[];
    static encodeHmsPeer(peer: any): HMSPeer;
    static encodeHmsPeerUpdate(hmsPeerUpdateOrdinal: string): import("./HMSPeerUpdate").HMSPeerUpdate | undefined;
    static encodeHmsAudioTrack(track: any, id: string): HMSAudioTrack;
    static encodeHmsVideoTrack(track: any, id: string): HMSVideoTrack;
    static encodeHmsAuxiliaryTracks(tracks: any, id: string): HMSTrack[];
    static encodeHmsTrack(track: any, id: string): HMSTrack;
    static encodeHmsLocalPeer(peer: any, id: string): HMSLocalPeer;
    static encodeHmsAudioTrackSettings(settings: any): HMSAudioTrackSettings;
    static encodeHmsVideoTrackSettings(settings: any): HMSVideoTrackSettings;
    static encodeHmsVideoResolution(resolution: any): HMSVideoResolution;
    static encodeHmsLocalAudioTrack(track: any, id: string): HMSLocalAudioTrack;
    static encodeHmsLocalVideoTrack(track: any, id: string): HMSLocalVideoTrack;
    static encodeHmsRemotePeers(peers: any, id: string): HMSRemotePeer[];
    static encodeHmsRemotePeer(peer: any, id: string): HMSRemotePeer;
    static encodeHmsRemoteAudioTrack(track: any, id: string): HMSRemoteAudioTrack;
    static encodeHmsRemoteVideoTrack(track: any, id: string): HMSRemoteVideoTrack;
    static encodeHmsPreviewTracks(previewTracks: any[], id: string): HMSTrack[];
    static encodeHmsPreviewForRoleTracks(previewTracks: any[], id: string): (HMSLocalAudioTrack | HMSLocalVideoTrack)[];
    static encodeHmsRoles(roles: any[]): HMSRole[];
    static encodeHmsRole(role: any): HMSRole;
    static encodeHmsRoleChangeRequest(data: any): HMSRoleChangeRequest;
    static encodeHmsChangeTrackStateRequest(data: HMSChangeTrackStateRequest): HMSChangeTrackStateRequest;
    static encodeRTCStats(data: any): HMSRTCStatsReport;
    static encodeRTCStatsUnit(data: any): HMSRTCStats;
    static encodeHmsSpeakers(data: any, id: string): HMSSpeaker[];
    static encodeHmsSpeaker(data: any, id: string): HMSSpeaker;
    static encodeBrowserRecordingState(data: any): HMSBrowserRecordingState;
    static encodeServerRecordingState(data: any): HMSServerRecordingState;
    static encodeRTMPStreamingState(data: any): HMSRtmpStreamingState;
    static encodeDate(dateData: any): Date | undefined;
    static encodeHLSStreamingState(data: any): HMSHLSStreamingState;
    static encodeHLSRecordingState(data: any): HMSHLSRecordingState | undefined;
    static encodeHLSVariants(data: any): HMSHLSVariant[];
    static getHLSVariantPlaylistType(type: String): HMSHLSPlaylistType;
    static encodeHMSNetworkQuality(data: any): HMSNetworkQuality | undefined;
    static encodeHMSMessage(data: any): HMSMessage | undefined;
    static encodeHMSMessageRecipient(data: any): HMSMessageRecipient;
    static encodeHMSException(data: any): HMSException;
    static encodeHMSLocalAudioStats(data: any): HMSLocalAudioStats;
    static encodeHMSLocalVideoStats(data: any[]): HMSLocalVideoStats[];
    static encodeHMSRemoteAudioStats(data: any): HMSRemoteAudioStats;
    static encodeHMSRemoteVideoStats(data: any): HMSRemoteVideoStats;
    static encodeHMSSimulcastLayerDefinition(data: any[]): HMSSimulcastLayerDefinition[];
    static encodeHMSQualityLimitationReasons(data: any): HMSQualityLimitationReasons;
    static transformHMSHLSCueEventData<C extends object, T>(data: C): T;
    static encodeTranscriptions(data: Array<any>): Array<Transcriptions>;
    static transformTranscripts(data: Array<any>): void;
}
