import { HMSAudioTrack } from './HMSAudioTrack';
import type { HMSAudioTrackSettings } from './HMSAudioTrackSettings';
import type { HMSTrackType } from './HMSTrackType';
import type { HMSTrackSource } from './HMSTrackSource';
export declare class HMSLocalAudioTrack extends HMSAudioTrack {
    settings?: HMSAudioTrackSettings;
    id: string;
    /**
     * Switches Audio of current user on/off depending upon the value of isMute
     *
     * @param {boolean} isMute
     * @memberof HMSLocalAudioTrack
     */
    setMute(isMute: boolean): void;
    getVolume: () => Promise<any>;
    constructor(params: {
        id: string;
        trackId: string;
        source?: HMSTrackSource;
        trackDescription?: string;
        isMute?: boolean;
        settings?: HMSAudioTrackSettings;
        type?: HMSTrackType;
    });
}
