import { HMSPeer } from './HMSPeer';
import type { HMSVideoTrackSettings } from './HMSVideoTrackSettings';
import type { HMSAudioTrackSettings } from './HMSAudioTrackSettings';
import { HMSLocalAudioTrack } from './HMSLocalAudioTrack';
import { HMSLocalVideoTrack } from './HMSLocalVideoTrack';
import type { HMSTrackType } from './HMSTrackType';
import type { HMSTrackSource } from './HMSTrackSource';
export declare class HMSLocalPeer extends HMSPeer {
    private localAudio?;
    private localVideo?;
    localAudioTrack: () => HMSLocalAudioTrack | undefined;
    localVideoTrack: () => HMSLocalVideoTrack | undefined;
    constructor(params: {
        peerID: string;
        name: string;
        localAudioTrackData?: {
            id: string;
            trackId: string;
            source?: HMSTrackSource;
            trackDescription?: string;
            isMute?: boolean;
            settings?: HMSAudioTrackSettings;
            type: HMSTrackType;
        };
        localVideoTrackData?: {
            id: string;
            trackId: string;
            source?: HMSTrackSource;
            trackDescription?: string;
            isMute?: boolean;
            settings?: HMSVideoTrackSettings;
            type: HMSTrackType;
        };
    });
}
