import { HMSVideoTrack } from './HMSVideoTrack';
import type { HMSVideoTrackSettings } from './HMSVideoTrackSettings';
import type { HMSTrackType } from './HMSTrackType';
import type { HMSTrackSource } from './HMSTrackSource';
export declare class HMSLocalVideoTrack extends HMSVideoTrack {
    settings?: HMSVideoTrackSettings;
    id: string;
    /**
     * switches camera between front/back
     *
     * @memberof HMSSDK
     */
    switchCamera: () => void;
    /**
     * Switches local video feed on/off depending upon the value of isMute
     *
     * @param {boolean} isMute
     * @memberof HMSLocalVideoTrack
     */
    setMute(isMute: boolean): void;
    constructor(params: {
        id: string;
        trackId: string;
        source?: HMSTrackSource;
        trackDescription?: string;
        isMute?: boolean;
        settings?: HMSVideoTrackSettings;
        type?: HMSTrackType;
    });
}
