import { HMSLogLevel } from './HMSLogLevel';
export declare let logger: HMSLogger | undefined;
export declare const getLogger: () => HMSLogger | undefined;
export declare const setLogger: (id: string, hmsLogger?: HMSLogger) => void;
export declare class HMSLogger {
    private _verbose;
    private _warning;
    private _error;
    private onLog?;
    constructor(params?: {
        verbose: boolean;
        warning: boolean;
        error: boolean;
    });
    verbose(message: string, data: any): void;
    warn(message: string, data: any): void;
    error(message: string, data: any): void;
    setLogListener(callback: Function): void;
    updateLogLevel(level: HMSLogLevel, value: boolean): void;
    getTimestamp(): string;
}
