import { HMSPeerUpdate } from './HMSPeerUpdate';
import { HMSTrackUpdate } from './HMSTrackUpdate';
import type { HMSTrack } from './HMSTrack';
import type { HMSNetworkQuality } from './HMSNetworkQuality';
import type { HMSRole } from './HMSRole';
import type { HMSAudioTrack } from './HMSAudioTrack';
import type { HMSVideoTrack } from './HMSVideoTrack';
import type { HMSPeerType } from './HMSPeerType';
export declare let hmsPeersCache: HMSPeersCache | undefined;
export declare const getHmsPeersCache: () => HMSPeersCache | undefined;
export declare const setHmsPeersCache: (_hmsPeersCache: HMSPeersCache) => void;
export declare const clearHmsPeersCache: () => void;
export type HMSPeerCacheProps = {
    peerID?: string | undefined;
    name?: string | undefined;
    isLocal?: boolean | undefined;
    networkQuality?: HMSNetworkQuality | undefined;
    customerUserID?: string | undefined;
    metadata?: string | undefined;
    role?: HMSRole | undefined;
    audioTrack?: HMSAudioTrack | undefined;
    videoTrack?: HMSVideoTrack | undefined;
    auxiliaryTracks?: HMSTrack[] | undefined;
    isHandRaised?: boolean | undefined;
    type?: HMSPeerType | undefined;
};
export declare class HMSPeersCache {
    private _data;
    private id;
    constructor(id: string);
    getProperty<T extends keyof HMSPeerCacheProps>(peerId: string, property: T): HMSPeerCacheProps[T] | undefined;
    updatePeerCache(peerId: string, data: Partial<Record<keyof HMSPeerCacheProps | 'track', any>>, updateType?: HMSPeerUpdate | HMSTrackUpdate): void;
    cleanup(): void;
}
export declare function getPeerPropertyFromNative<T extends keyof HMSPeerCacheProps>(id: string, peerId: string, property: T): HMSPeerCacheProps[T];
