import type { TranscriptionsMode } from './transcriptions';
export interface HMSWhiteboardPermission {
    admin?: boolean;
    write?: boolean;
    read?: boolean;
}
export interface HMSTranscriptionPermissions {
    admin: boolean;
    mode?: TranscriptionsMode;
}
export declare class HMSPermissions {
    endRoom?: boolean;
    removeOthers?: boolean;
    unmute?: boolean;
    mute?: boolean;
    changeRole?: boolean;
    browserRecording?: boolean;
    hlsStreaming?: boolean;
    rtmpStreaming?: boolean;
    pollRead?: boolean;
    pollWrite?: boolean;
    whiteboard?: HMSWhiteboardPermission;
    transcriptions?: Array<HMSTranscriptionPermissions>;
    constructor(params?: {
        endRoom?: boolean;
        removeOthers?: boolean;
        unmute?: boolean;
        mute?: boolean;
        changeRole?: boolean;
        browserRecording?: boolean;
        hlsStreaming?: boolean;
        rtmpStreaming?: boolean;
        pollRead?: boolean;
        pollWrite?: boolean;
        whiteboard?: HMSWhiteboardPermission;
        transcriptions?: Array<HMSTranscriptionPermissions>;
    });
}
