import { HMSVideoTrack } from './HMSVideoTrack';
import type { HMSTrackType } from './HMSTrackType';
import type { HMSLayer } from './HMSLayer';
import type { HMSSimulcastLayerDefinition } from './HMSSimulcastLayerDefinition';
import type { HMSTrackSource } from './HMSTrackSource';
export declare class HMSRemoteVideoTrack extends HMSVideoTrack {
    /**
     * Switches Video of remote user on/off depending upon the value of playbackAllowed
     *
     * @param {boolean} playbackAllowed
     * @memberof HMSRemoteVideoTrack
     */
    setPlaybackAllowed(playbackAllowed: boolean): void;
    isPlaybackAllowed: () => Promise<any>;
    getLayer(): Promise<HMSLayer>;
    getLayerDefinition(): Promise<HMSSimulcastLayerDefinition[]>;
    setLayer(layer: HMSLayer): Promise<any>;
    constructor(params: {
        trackId: string;
        source?: HMSTrackSource;
        trackDescription?: string;
        isMute?: boolean;
        playbackAllowed?: boolean;
        id: string;
        isDegraded?: boolean;
        type?: HMSTrackType;
    });
}
