import type { HMSPeer } from './HMSPeer';
import type { HMSRtmpStreamingState } from './HMSRtmpStreamingState';
import type { HMSServerRecordingState } from './HMSServerRecordingState';
import type { HMSBrowserRecordingState } from './HMSBrowserRecordingState';
import type { HMSHLSStreamingState } from './HMSHLSStreamingState';
import type { HMSHLSRecordingState } from './HMSHLSRecordingState';
import type { HMSLocalPeer } from './HMSLocalPeer';
import type { Transcriptions } from './transcriptions/Transcriptions';
export declare class HMSRoom {
    id: string;
    constructor(params: {
        id: string;
    });
    get sessionId(): string;
    get name(): string;
    get metaData(): string | undefined;
    get peers(): HMSPeer[];
    get browserRecordingState(): HMSBrowserRecordingState;
    get rtmpHMSRtmpStreamingState(): HMSRtmpStreamingState;
    get serverRecordingState(): HMSServerRecordingState;
    get hlsStreamingState(): HMSHLSStreamingState;
    get hlsRecordingState(): HMSHLSRecordingState | undefined;
    get peerCount(): number | null;
    get localPeer(): HMSLocalPeer;
    get isLargeRoom(): boolean;
    get transcriptions(): Array<Transcriptions>;
}
