import type { HMSRoom } from './HMSRoom';
import { HMSRoomUpdate } from './HMSRoomUpdate';
export declare let hmsRoomCache: HMSRoomCache | undefined;
export declare const getHmsRoomCache: () => HMSRoomCache | undefined;
export declare const setHmsRoomCache: (_hmsRoomCache: HMSRoomCache) => void;
export declare const clearHmsRoomCache: () => void;
export type HMSRoomCacheProps = Partial<Omit<HMSRoom, 'id'>>;
export declare class HMSRoomCache {
    private _data;
    private id;
    constructor(id: string);
    getProperty<T extends keyof Required<HMSRoomCacheProps>>(property: T): Required<HMSRoomCacheProps>[T];
    updateRoomCache(data: Record<keyof HMSRoomCacheProps, any>, updateType?: HMSRoomUpdate): void;
    cleanup(): void;
}
export declare function getHMSRoomPropertyFromNative<T extends keyof HMSRoomCacheProps>(id: string, property: T): Required<HMSRoomCacheProps>[T];
