import React from 'react';
import type { StyleProp, ViewStyle } from 'react-native';
import type { HLSPlayerDurationDetails } from '../../types';
export interface HMSHLSPlayerProps {
    url?: string;
    style?: StyleProp<ViewStyle>;
    containerStyle?: StyleProp<ViewStyle>;
    aspectRatio?: number;
    enableStats?: boolean;
    enableControls?: boolean;
}
export interface HMSHLSPlayerRefProperties {
    play: (url?: string) => void;
    stop: () => void;
    pause: () => void;
    resume: () => void;
    seekForward: (seconds: number) => void;
    seekBackward: (seconds: number) => void;
    seekToLivePosition: () => void;
    setVolume: (level: number) => void;
    isClosedCaptionSupported: () => Promise<boolean>;
    isClosedCaptionEnabled: () => Promise<boolean>;
    enableClosedCaption: () => void;
    disableClosedCaption: () => void;
    getPlayerDurationDetails: () => Promise<HLSPlayerDurationDetails>;
}
export declare const HMSHLSPlayer: React.ForwardRefExoticComponent<HMSHLSPlayerProps & React.RefAttributes<HMSHLSPlayerRefProperties>>;
