import type { DependencyList } from 'react';
import type { HMSHLSPlayerStatsUpdateEventData } from '../../types';
import type { HMSHLSPlayerCue, HMSHLSPlayerPlaybackError, HMSHLSPlayerStatsError } from '../../stores/types';
export declare const useHMSHLSPlayerPlaybackState: () => import("../../types").HMSHLSPlayerPlaybackState;
export declare const useHMSHLSPlayerResolution: () => import("../../stores/types").HMSHLSPlayerResolution;
export declare const useHMSHLSPlayerStats: () => {
    stats: HMSHLSPlayerStatsUpdateEventData;
    error: HMSHLSPlayerStatsError;
};
export declare const useHMSHLSPlayerStat: <T extends keyof HMSHLSPlayerStatsUpdateEventData>(stat: T) => HMSHLSPlayerStatsUpdateEventData[T];
export declare const useHMSHLSPlayerSubtitles: () => string | null;
export declare const useIsHLSStreamLive: (liveOffsetMillis?: number) => boolean;
export declare const useHMSHLSPlayerStatsError: (callback: (error: NonNullable<HMSHLSPlayerStatsError>) => void, deps: DependencyList) => void;
export declare const useHMSHLSPlayerPlaybackError: (callback: (error: NonNullable<HMSHLSPlayerPlaybackError>) => void, deps: DependencyList) => void;
export declare const useHMSHLSPlayerCue: (callback: (error: NonNullable<HMSHLSPlayerCue>) => void, deps: DependencyList) => void;
export declare const setHMSHLSPlayerPlaybackState: (playbackState: import("../../types").HMSHLSPlayerPlaybackState) => void;
export declare const setHMSHLSPlayerResolution: (resolution: import("../../stores/types").HMSHLSPlayerResolution) => void;
export declare const setHMSHLSPlayerCue: (cue: import("../../stores/types").HMSHLSPlayerPlaybackCue) => void;
export declare const setHMSHLSPlayerPlaybackError: (error: HMSHLSPlayerPlaybackError) => void;
export declare const setHMSHLSPlayerStats: (stats: HMSHLSPlayerStatsUpdateEventData) => void;
export declare const setHMSHLSPlayerStatsError: (error: HMSHLSPlayerStatsError) => void;
export declare const setHMSHLSPlayerSubtitles: (subtitles: string | null) => void;
