export declare enum SoftInputModes {
    SOFT_INPUT_ADJUST_NOTHING = 48,
    SOFT_INPUT_ADJUST_PAN = 32,
    SOFT_INPUT_ADJUST_RESIZE = 16,
    SOFT_INPUT_ADJUST_UNSPECIFIED = 0
}
/**
 * [Android Only] Sets the `windowSoftInputMode` value for the current activity
 * @param inputMode window softinput moede to use. It can be any variant of the {@link SoftInputModes} enum
 */
export declare function setSoftInputMode(inputMode: SoftInputModes): void;
/**
 * [Android Only] Gets the current `windowSoftInputMode` value of the current activity
 * @returns current `windowSoftInputMode` ({@link SoftInputModes}) value of the current activity
 */
export declare function getSoftInputMode(): SoftInputModes;
